module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/dist/";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 64);
/******/ })
/************************************************************************/
/******/ ({

/***/ 0:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return normalizeComponent; });
/* globals __VUE_SSR_CONTEXT__ */

// IMPORTANT: Do NOT use ES2015 features in this file (except for modules).
// This module is a runtime utility for cleaner component module output and will
// be included in the final webpack user bundle.

function normalizeComponent (
  scriptExports,
  render,
  staticRenderFns,
  functionalTemplate,
  injectStyles,
  scopeId,
  moduleIdentifier, /* server only */
  shadowMode /* vue-cli only */
) {
  // Vue.extend constructor export interop
  var options = typeof scriptExports === 'function'
    ? scriptExports.options
    : scriptExports

  // render functions
  if (render) {
    options.render = render
    options.staticRenderFns = staticRenderFns
    options._compiled = true
  }

  // functional template
  if (functionalTemplate) {
    options.functional = true
  }

  // scopedId
  if (scopeId) {
    options._scopeId = 'data-v-' + scopeId
  }

  var hook
  if (moduleIdentifier) { // server build
    hook = function (context) {
      // 2.3 injection
      context =
        context || // cached call
        (this.$vnode && this.$vnode.ssrContext) || // stateful
        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext) // functional
      // 2.2 with runInNewContext: true
      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__
      }
      // inject component styles
      if (injectStyles) {
        injectStyles.call(this, context)
      }
      // register component module identifier for async chunk inferrence
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier)
      }
    }
    // used by ssr in case component is cached and beforeCreate
    // never gets called
    options._ssrRegister = hook
  } else if (injectStyles) {
    hook = shadowMode
      ? function () {
        injectStyles.call(
          this,
          (options.functional ? this.parent : this).$root.$options.shadowRoot
        )
      }
      : injectStyles
  }

  if (hook) {
    if (options.functional) {
      // for template-only hot-reload because in that case the render fn doesn't
      // go through the normalizer
      options._injectStyles = hook
      // register for functional component in vue file
      var originalRender = options.render
      options.render = function renderWithStyleInjection (h, context) {
        hook.call(context)
        return originalRender(h, context)
      }
    } else {
      // inject component registration as beforeCreate hook
      var existing = options.beforeCreate
      options.beforeCreate = existing
        ? [].concat(existing, hook)
        : [hook]
    }
  }

  return {
    exports: scriptExports,
    options: options
  }
}


/***/ }),

/***/ 1:
/***/ (function(module, exports) {

module.exports = require("gleaf/lib/utils/dom");

/***/ }),

/***/ 52:
/***/ (function(module, exports) {

module.exports = require("gleaf/lib/utils/dragger");

/***/ }),

/***/ 64:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// CONCATENATED MODULE: ./node_modules/_vue-loader@15.9.5@vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/_vue-loader@15.9.5@vue-loader/lib??vue-loader-options!./packages/modal/src/main.vue?vue&type=template&id=a1d5a32c&
var render = function() {
  var _obj
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "transition",
    {
      attrs: { name: _vm.transitionType },
      on: {
        "after-enter": function($event) {
          return _vm.$emit("open")
        }
      }
    },
    [
      _c(
        "div",
        {
          directives: [
            {
              name: "show",
              rawName: "v-show",
              value: _vm.visible,
              expression: "visible"
            }
          ],
          staticClass: "yl-modal__wrapper",
          on: {
            click: function($event) {
              if ($event.target !== $event.currentTarget) {
                return null
              }
              return _vm.handleWrapperClick($event)
            }
          }
        },
        [
          _c(
            "div",
            {
              ref: "mymodal",
              class: [
                {
                  "is-fullscreen": _vm.fullscreen,
                  "is-rightslide": _vm.rightslide
                },
                _vm.customClass,
                "yl-modal"
              ],
              style: _vm.style
            },
            [
              _c(
                "div",
                {
                  class: [
                    "yl-modal__header",
                    ((_obj = {}), (_obj["yl-modal--center"] = _vm.center), _obj)
                  ]
                },
                [
                  _vm._t("title", [
                    _c("span", { staticClass: "'yl-modal__title'" }, [
                      _vm._v(_vm._s(_vm.title))
                    ])
                  ]),
                  _vm.showClose
                    ? _c(
                        "button",
                        {
                          staticClass: "yl-modal__headerbtn",
                          attrs: { type: "button", "aria-label": "Close" },
                          on: { click: _vm.handleClose }
                        },
                        [
                          _c("i", {
                            staticClass: "yl-modal__close yl-icon-close"
                          })
                        ]
                      )
                    : _vm._e()
                ],
                2
              ),
              _vm.renderComplete
                ? _c(
                    "div",
                    { staticClass: "yl-modal__body" },
                    [_vm._t("default")],
                    2
                  )
                : _vm._e(),
              _vm.$slots.footer
                ? _c(
                    "div",
                    { staticClass: "yl-modal__footer" },
                    [_vm._t("footer")],
                    2
                  )
                : _vm._e()
            ]
          )
        ]
      )
    ]
  )
}
var staticRenderFns = []
render._withStripped = true


// CONCATENATED MODULE: ./packages/modal/src/main.vue?vue&type=template&id=a1d5a32c&

// EXTERNAL MODULE: external "gleaf/lib/utils/dom"
var dom_ = __webpack_require__(1);

// CONCATENATED MODULE: ./packages/modal/src/layer/layer-manage.js
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }



var layer_manage_getMask = function getMask() {
  var maskDom = Object(dom_["createElement"])('div');
  Object(dom_["stopDefaultEvent"])(maskDom, 'touchmove');
  return maskDom;
};

var layer_manage_LayerManage = function () {
  function LayerManage(zIndex) {
    _classCallCheck(this, LayerManage);

    this.zIndex = zIndex;
    this.maskDom = null;
    this.modalList = [];
  }

  LayerManage.prototype.doOnMaskClick = function doOnMaskClick() {
    this.closeMask();
  };

  LayerManage.prototype.setMaskIn = function setMaskIn(modal, mask) {
    var _this = this;

    Object(dom_["addClass"])(this.maskDom, 'v-mask-enter');
    Object(dom_["setStyle"])(this.maskDom, { display: mask ? 'block' : 'none' });
    Object(dom_["setStyle"])(this.maskDom, { zIndex: this.zIndex });
    Object(dom_["setStyle"])(modal, { zIndex: this.zIndex + 1 });
    setTimeout(function () {
      Object(dom_["removeClass"])(_this.maskDom, 'v-mask-enter');
    }, 200);
  };

  LayerManage.prototype.openMask = function openMask(modal, mask) {
    var _this2 = this;

    if (this.$isServer) return;
    this.modalList.push({ modal: modal, mask: mask });
    if (this.maskDom !== null) {
      this.setMaskIn(modal, mask);
      return;
    }
    var maskDom = layer_manage_getMask();
    Object(dom_["addClassList"])(maskDom, ['v-mask', 'v-mask-enter']);
    Object(dom_["setStyle"])(maskDom, { zIndex: this.zIndex, display: mask ? 'block' : 'none' });
    Object(dom_["setStyle"])(modal, { zIndex: this.zIndex + 1 });
    Object(dom_["on"])(maskDom, 'click', function () {
      _this2.doOnMaskClick && _this2.doOnMaskClick();
    });
    Object(dom_["appendToBody"])(this.maskDom = maskDom);
    setTimeout(function () {
      Object(dom_["removeClass"])(maskDom, 'v-mask-enter');
    }, 200);
  };

  LayerManage.prototype.closeMask = function closeMask() {
    var _this3 = this;

    this.modalList.pop();
    if (this.modalList.length === 0) {
      Object(dom_["addClass"])(this.maskDom, 'v-mask-leave');
      Object(dom_["setStyle"])(this.maskDom, { display: 'none' });
      setTimeout(function () {
        Object(dom_["removeClass"])(_this3.maskDom, 'v-mask-leave');
      }, 200);
    } else {
      Object(dom_["setStyle"])(this.maskDom, {
        zIndex: this.previousLayer(),
        display: this.modalList[this.modalList.length - 1].mask ? 'block' : 'none'
      });
    }
  };

  LayerManage.prototype.nextLayer = function nextLayer() {
    return this.zIndex += 2;
  };

  LayerManage.prototype.previousLayer = function previousLayer() {
    return this.zIndex -= 2;
  };

  LayerManage.prototype.getCurrentLayer = function getCurrentLayer() {
    return this.zIndex;
  };

  return LayerManage;
}();

/* harmony default export */ var layer_manage = (new layer_manage_LayerManage(1998));
// CONCATENATED MODULE: ./packages/modal/src/layer/index.js


/* harmony default export */ var src_layer = ({
  props: {
    visible: {
      type: Boolean,
      default: false
    }
  },
  watch: {
    visible: function visible(val) {
      if (val) {
        this.nextLayer();
        layer_manage.openMask(this.$el, this.mask);
      } else {
        layer_manage.closeMask(this.$el, this.mask);
      }
    }
  },
  methods: {
    nextLayer: function nextLayer() {
      layer_manage.nextLayer();
    },
    previousLayer: function previousLayer() {
      layer_manage.previousLayer();
    },
    doAfterClose: function doAfterClose() {}
  },
  beforeMount: function beforeMount() {}
});
// EXTERNAL MODULE: external "gleaf/lib/utils/dragger"
var dragger_ = __webpack_require__(52);
var dragger_default = /*#__PURE__*/__webpack_require__.n(dragger_);

// CONCATENATED MODULE: ./node_modules/_babel-loader@7.1.5@babel-loader/lib!./node_modules/_vue-loader@15.9.5@vue-loader/lib??vue-loader-options!./packages/modal/src/main.vue?vue&type=script&lang=js&
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//





/* harmony default export */ var mainvue_type_script_lang_js_ = ({
  name: 'YlModal',
  componentName: 'YlModal',
  mixins: [src_layer],
  props: {
    title: {
      type: String,
      default: ''
    },
    mask: {
      type: Boolean,
      default: true
    },
    openResetDrag: {
      type: Boolean,
      default: true
    },
    closeOnClickModal: {
      type: Boolean,
      default: true
    },
    showClose: {
      type: Boolean,
      default: true
    },
    width: String,
    fullscreen: Boolean,
    rightslide: Boolean,
    customClass: {
      type: String,
      default: ''
    },
    top: {
      type: String,
      default: '15vh'
    },
    beforeClose: Function,
    center: {
      type: Boolean,
      default: false
    },
    visible: {
      type: Boolean,
      default: false
    },
    draggable: {
      type: Boolean,
      default: false
    },
    scroll: {
      type: Boolean,
      default: false
    },
    lockBodyScroll: {
      type: Boolean,
      default: false
    }
  },
  data: function data() {
    return {
      closed: false,
      renderComplete: false,
      dragger: null
    };
  },

  watch: {
    visible: function visible(val) {
      var _this = this;

      if (val) {
        if (this.lockBodyScroll) {
          document.body.style.overflow = 'hidden';
        }

        this.closed = false;
        this.$nextTick(function () {
          _this.open();
          if (_this.openResetDrag && _this.draggable) {
            _this.resetDrag();
          }
        });
      } else {
        this.$emit('update:visible', false);
        document.body.style.overflow = '';
      }
    }
  },
  computed: {
    style: function style() {
      var style = {};
      if (this.width) {
        style.width = this.fullscreen ? '100%' : this.width;
      }
      style.position = this.scroll ? 'relative' : '';

      if (!this.fullscreen && !this.rightslide) {
        style.top = this.top;
      }

      return style;
    },
    transitionType: function transitionType() {
      if (this.rightslide) {
        return 'modal-slide';
      }
      return 'modal-fade';
    }
  },
  methods: {
    open: function open() {
      this.renderComplete = true;
    },
    handleWrapperClick: function handleWrapperClick() {
      if (!this.closeOnClickModal) return;
      this.$emit('before-close-by-wrap-click');
      this.handleClose();
    },
    handleClose: function handleClose() {
      if (typeof this.beforeClose === 'function') {
        this.beforeClose(this.hide);
      } else {
        this.hide();
      }
    },
    hide: function hide(cancel) {
      if (cancel !== false) {
        this.$emit('update:visible', false);
        this.$emit('close');
        this.closed = true;
      }
    },
    resetDrag: function resetDrag() {
      Object(dom_["setStyle"])(this.$refs.mymodal, { left: '', top: '', margin: '' });
    }
  },
  mounted: function mounted() {
    if (this.visible) {
      this.open();
    }
    if (this.draggable && !this.fullscreen && !this.scroll) {
      this.dragger = new dragger_default.a(this.$refs.mymodal).addDraggableListeners();
    }
  },
  beforeDestroy: function beforeDestroy() {
    if (this.draggable && !this.fullscreen && !this.scroll) {
      this.dragger.destroyed();
    }
  },
  destroyed: function destroyed() {}
});
// CONCATENATED MODULE: ./packages/modal/src/main.vue?vue&type=script&lang=js&
 /* harmony default export */ var src_mainvue_type_script_lang_js_ = (mainvue_type_script_lang_js_); 
// EXTERNAL MODULE: ./node_modules/_vue-loader@15.9.5@vue-loader/lib/runtime/componentNormalizer.js
var componentNormalizer = __webpack_require__(0);

// CONCATENATED MODULE: ./packages/modal/src/main.vue





/* normalize component */

var component = Object(componentNormalizer["a" /* default */])(
  src_mainvue_type_script_lang_js_,
  render,
  staticRenderFns,
  false,
  null,
  null,
  null
  
)

/* hot reload */
if (false) { var api; }
component.options.__file = "packages/modal/src/main.vue"
/* harmony default export */ var main = (component.exports);
// CONCATENATED MODULE: ./packages/modal/index.js


/* istanbul ignore next */
main.install = function (Vue) {
  Vue.component(main.name, main);
};

/* harmony default export */ var packages_modal = __webpack_exports__["default"] = (main);

/***/ })

/******/ });