export default {
  yl: {
    colorpicker: {
      confirm: 'Confirmar',
      clear: 'Despejar'
    },
    datepicker: {
      now: 'Ahora',
      today: 'Hoy',
      cancel: 'Cancelar',
      clear: 'Despejar',
      confirm: 'Confirmar',
      selectDate: 'Seleccionar fecha',
      selectTime: 'Seleccionar hora',
      startDate: 'Fecha Incial',
      startTime: 'Hora Inicial',
      endDate: 'Fecha Final',
      endTime: 'Hora Final',
      prevYear: 'Año Anterior',
      nextYear: 'Próximo Año',
      prevMonth: 'Mes Anterior',
      nextMonth: 'Próximo Mes',
      year: '',
      month1: 'enero',
      month2: 'febrero',
      month3: 'marzo',
      month4: 'abril',
      month5: 'mayo',
      month6: 'junio',
      month7: 'julio',
      month8: 'agosto',
      month9: 'septiembre',
      month10: 'octubre',
      month11: 'noviembre',
      month12: 'diciembre',
      // week: 'semana',
      weeks: {
        sun: 'dom',
        mon: 'lun',
        tue: 'mar',
        wed: 'mié',
        thu: 'jue',
        fri: 'vie',
        sat: 'sáb'
      },
      months: {
        jan: 'ene',
        feb: 'feb',
        mar: 'mar',
        apr: 'abr',
        may: 'may',
        jun: 'jun',
        jul: 'jul',
        aug: 'ago',
        sep: 'sep',
        oct: 'oct',
        nov: 'nov',
        dec: 'dic'
      }
    },
    select: {
      loading: 'Cargando',
      noMatch: 'No hay datos que coincidan',
      noData: 'Sin datos',
      placeholder: 'Seleccionar'
    },
    cascader: {
      noMatch: 'No hay datos que coincidan',
      loading: 'Cargando',
      placeholder: 'Seleccionar',
      noData: 'Sin datos'
    },
    pagination: {
      goto: 'Ir a',
      pagesize: '/página',
      total: 'Total {total}',
      pageClassifier: ''
    },
    messagebox: {
      confirm: 'Aceptar',
      cancel: 'Cancelar',
      error: 'Entrada inválida'
    },
    upload: {
      deleteTip: 'press delete to remove', // to be translated
      delete: 'Eliminar',
      preview: 'Vista Previa',
      continue: 'Continuar'
    },
    table: {
      emptyText: 'Sin Datos',
      confirmFilter: 'Confirmar',
      resetFilter: 'Reiniciar',
      clearFilter: 'Todos',
      sumText: 'Suma'
    },
    tree: {
      emptyText: 'Sin Datos',
      searchEmptyText: 'No se encontraron coincidencias',
      loading: 'Cargando.',
      select: 'Seleccionado.',
      clearAll: 'Vaciar todo',
      searchKey: 'Clave de búsqueda',
      externalContacts: 'Contacto externo',
      addExternalContacts: 'Añadir contacto externo',
      add: 'Adición',
      setPresetMember: 'Configuración predeterminada'
    },
    transfer: {
      noMatch: 'No hay datos que coincidan',
      noData: 'Sin datos',
      titles: ['Lista 1', 'Lista 2'],
      filterPlaceholder: 'Ingresar palabra clave',
      noCheckedFormat: '{total} artículos',
      hasCheckedFormat: '{checked}/{total} revisados'
    },
    image: {
      error: 'HA FALLADO'
    },
    pageHeader: {
      title: 'Volver'
    },
    popconfirm: {
      confirmButtonText: 'Si',
      cancelButtonText: 'No'
    },
    slideverify: {
      title: 'Verifique la seguridad.',
      refresh: 'Actualizar autenticación',
      optip: 'Llenar el rompecabezas',
      success: 'Verificación Exitosa'
    },
    tablecan: {
      select: 'Seleccionado {num}',
      selectAll: 'Seleccionar todas las páginas'
    },
    password: {
      require: 'Requisitos de contraseña',
      cdi1: '8~{maxlength} caracteres',
      cdi2: 'Al menos dos de los siguientes: números, letras minúsculas y mayúsculas, y símbolos (excluyendo el espacio)',
      cdi3: 'Solo contiene números, letras minúsculas y mayúsculas y símbolos (excluyendo el espacio)',
      strength: 'Seguridad de la contraseña',
      weak: 'Débiles',
      in: 'Medio',
      strong: 'Fuerte'
    },
    searchpanel: {
      search: 'Buscar',
      resetSearch: 'Reiniciar',
      all: 'Todos'
    }
  }
};
